package nl.iobyte.themeparkconnector.api.operator.objects.panel;

public class OperatorItemState {

    private final String id, name, cover, text_color, background_color;
    private final transient String command;
    private final boolean glow;

    public OperatorItemState(String id, String name, String cover, String command) {
        if(command !=null && command.startsWith("/"))
            command = command.replaceFirst("/", "");

        this.id = id;
        this.name = name;
        this.cover = cover;
        this.command = command;
        this.text_color = "#fff";
        this.background_color = "#666";
        this.glow = false;
    }

    public OperatorItemState(String id, String name, String cover, String command, String text_color, String background_color, boolean glow) {
        if(command !=null && command.startsWith("/"))
            command = command.replaceFirst("/", "");

        this.id = id;
        this.name = name;
        this.cover = cover;
        this.command = command;
        this.text_color = text_color;
        this.background_color = background_color;
        this.glow = glow;
    }

    public String getID() {
        return id;
    }

    public String getName() {
        return name;
    }

    public String getCover() {
        return cover;
    }

    public String getCommand() {
        return command;
    }

    public String getTextColor() {
        return text_color;
    }

    public String getBackgroundColor() {
        return background_color;
    }

    public boolean isGlowing() {
        return glow;
    }

    public OperatorItemState copy(String command) {
        return new OperatorItemState(id, name, cover, command, text_color, background_color, glow);
    }

}
