package nl.iobyte.themeparkconnector.commands.subcommands;

import nl.iobyte.commandapi.arguments.StringArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.message.Text;
import org.bukkit.entity.Player;

import java.util.List;

public class VoucherCommand extends SubCommand {

    public VoucherCommand() {
        super(new String[]{"redeem"});

        addSyntax("/themeparkconnector redeem <voucher>")
                .addArgument(new StringArgument())
                .setAllowConsole(false);
    }

    //Get Token and redeem ticket
    public void onCommand(ICommandExecutor sender, List<Object> objects, int i) {
        String voucher = (String) objects.get(0);

        String result = ThemeParkConnector.getInstance().getAPI().getShowService().redeemTicket(
                ((Player) sender.getOriginal()).getUniqueId(),
                voucher
        );
        if(result.equals("true")) {
            sender.sendMessage(Text.color("&6Redeemed ticket with voucher: &L&f"+voucher));
            return;
        }

        ThemeParkConnector.getInstance().getLogger().warning(result);
        sender.sendMessage(Text.color("&4Invalid voucher: &L&f"+voucher));
    }

}
