package nl.iobyte.themeparkconnector.commands.subcommands.operator;

import nl.iobyte.commandapi.arguments.StringArgument;
import nl.iobyte.commandapi.objects.SubCommand;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.event.operator.OperatorStateEvent;
import nl.iobyte.themeparkconnector.api.message.Text;
import nl.iobyte.themeparkconnector.api.operator.objects.AttractionOperator;
import nl.iobyte.themeparkconnector.api.operator.objects.panel.OperatorItem;
import nl.iobyte.themeparkconnector.api.operator.objects.panel.OperatorItemState;
import nl.iobyte.themeparkconnector.commands.arguments.OperatorArgument;
import nl.iobyte.commandapi.interfaces.ICommandExecutor;
import java.util.List;

public class OperatorStateCommand extends SubCommand {

    public OperatorStateCommand()  {
        super("themeparkconnector.admin", "operator", "state");

        addSyntax("/themeparkconnector operator state <attraction> <item> <state>")
                .addArgument(new OperatorArgument());

        addSyntax("/themeparkconnector operator state <attraction> <item> <state> <data>")
                .addArgument(new OperatorArgument())
                .addArgument(new StringArgument());
    }

    public void onCommand(ICommandExecutor  sender, List<Object> list, int i) {
        AttractionOperator operator = (AttractionOperator) list.get(0);
        OperatorItem item = (OperatorItem) list.get(1);
        OperatorItemState state = (OperatorItemState) list.get(2);
        OperatorItemState old = item.getActiveState();
        if(state.getID().equals(old.getID())) {
            if(sender.isPlayer())
                sender.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &4Item already in state: &f"+state.getID()));

            return;
        }

        item.setActiveState(state.getID());
        ThemeParkConnector.getInstance().getAPI().getEventDispatcher().call(new OperatorStateEvent(
                operator,
                item,
                old,
                state,
                i == 0 ? "" : (String) list.get(3)
        ));

        if(sender.isPlayer())
            sender.sendMessage(Text.color("&6&lThemeParkConnectorMC &f➢ &aSuccessfully changed state of item to: &f"+state.getID()));
    }

}
